@use './styles/form-file-upload.variations' as variations;
@use './styles/form-file-upload.variables' as *;
@use '../../../global/styles/styles-variables' as *;
@use '../../../global/styles/utilities' as *;

:host {
  @include digi-form-file-upload--variables;
  $base: '.digi-form-file-upload';
  container-type: inline-size;
  display: block;
  width: 100%;

  a {
    font-weight: var(--digi--global--typography--font-weight--semibold);
    color: var(--digi--color--text--link);
  }

  .digi-form-file-upload {
    font-family: var(--digi--global--typography--font-family--default);

    &--small {
      @include variations.small;
    }

    &--medium {
      @include variations.medium;
    }

    &--large {
      @include variations.large;
    }

    &--has-errors {
      @include variations.error;
    }

    &__spinner {
      margin-right: 0.5rem;
      animation: animation__rotation 0.5s * 6 infinite linear;
      transform-origin: center;
      --digi--icon--height: #{rem(16)};

      @media (prefers-reduced-motion) {
        animation: none;
      }

      @keyframes animation__rotation {
        from {
          transform: rotate(0deg);
        }

        to {
          transform: rotate(359deg);
        }
      }
    }

    &__input {
      display: none;
    }

    &__button {
      margin: 0 0 auto rem(8);
      text-align: center;
      white-space: nowrap;
      background: none;
      border: none;
      cursor: pointer;
      font-weight: var(--digi--typography--button--font-weight--desktop);
      font-size: var(--digi--typography--body--font-size--desktop);
      color: var(--digi--form-file-upload--button-text--color--default);
      display: flex;
      align-items: center;
      font-family: var(--digi--global--typography--font-family--default);

      &:hover {
        color: var(--digi--form-file-upload--button-text--color--hover);
        .digi-form-file-upload__button-icon {
          --digi--icon--color: var(
            --digi--form-file-upload--button-text--color--hover
          );
        }
      }

      &:focus-visible{
        @include digi--focus();
      }

      &-icon {
        --digi--icon--height: 1.25rem;
        --digi--icon--width: 1.25rem;
        --digi--icon--color: var(--digi--color--icons--complementary-1);
        margin-left: 5px;
        padding: var(--ICON--PADDING);
        padding-right: 0;
        padding-left: 0;
        &:hover {
          --digi--icon--color: var(
            --digi--form-file-upload--button-text--color--hover
          );
        }
      }
    }

    &__upload-area {
      border-color: var(--COLOR--BORDER--DEFAULT);
      border-radius: var(--BORDER-RADIUS--DEFAULT);
      border-width: var(--BORDER-WIDTH--DEFAULT);
      border-style: var(--BORDER-STYLE--DEFAULT);
      max-width: var(--WIDTH);
      margin: 0;
      display: flex;
      flex-direction: column;
      background-color: var(--COLOR--BACKGROUND--DEFAULT);
      align-items: center;
      padding: var(--PADDING);
      margin-bottom: var(--digi--gutter--medium);
      margin-top: var(--digi--gutter--button-block-small);
      position: relative;
      cursor: pointer;

      &--hover {
        border-color: var(--COLOR--BORDER--HOVER);
      }

      &-overlay {
        position: absolute;
        width: 100%;
        height: 100%;
        background-color: var(--COLOR--BACKGROUND--HOVER);
        opacity: 0.1;
        top: 0;
        left: 0;
        z-index: 10;
      }
    }

    &__text-area {
      display: flex;
      flex-direction: column;
      align-items: center;
      justify-content: center;
      text-align: center;

      .paper-clip {
        padding-right: rem(8);
      }
    }

    &__files-list {
      max-width: none;
      padding: 0;
      margin: 0;
    }

    &__files {
      border-radius: var(--BORDER-RADIUS--DEFAULT);
      max-width: 100%;
      width: 100%;
      box-sizing: border-box;
      background-color: var(--COLOR--BACKGROUND--FILE-LIST);
      padding: var(--digi--gutter--largest-2) var(--digi--padding--large);
      margin-bottom: var(--digi--gutter--medium);
      margin-top: var(--digi--gutter--medium);
      padding-bottom: var(--digi--padding--smaller);
    }

    &__files-heading {
      font-family: var(--digi--form-file-upload--heading--font-family);
      font-size: var(--digi--typography--label--font-size--desktop);
      font-weight: var(--digi--form-file-upload--heading--font-weight);
      color: var(--digi--color--text--primary);
      margin: var(--digi--margin--small) 0 var(--digi--margin--medium) 0;
      display: block;

      &--and-errors {
        margin-top: var(--digi--margin--largest);
      }
    }

    &__error-list-container {
      display: flex;
      justify-content: space-between;
      padding-bottom: rem(12);
      &.with-files {
        border-bottom: var(--BORDER-WIDTH--DEFAULT) solid
          var(--digi--color--border--neutral-2);
      }

      .clear-button {
        max-height: rem(24);
        .clear-icon {
          padding-right: 0;
        }
      }
    }

    &__error-list {
      margin: 0;
      padding: 0;

      li {
        list-style: none;
        margin-bottom: rem(12);
      }
      li:last-of-type {
        margin-bottom: 0;
      }
    }

    &__item {
      margin: var(--digi--margin--small) 0;
      margin-bottom: var(--digi--margin--medium);
      width: 100%;
      box-sizing: border-box;
      &-container {
        list-style-type: none;

        &:nth-child(n + 2) {
          border-top: var(--BORDER-WIDTH--DEFAULT) solid
            var(--digi--color--border--neutral-2);
        }
      }

      &-pending-container {
        display: flex;
        justify-content: space-between;
        align-items: center;
        width: 100%;

        .info-wrapper {
          display: flex;
          justify-content: flex-start;
          align-items: center;
          height: auto;
          min-width: 20%;
        }
        .button-wrapper {
          display: flex;
          min-width: 20%;
          justify-content: flex-end;
          align-items: center;
        }

        p {
          margin: auto var(--digi--margin--small) !important;
          font-weight: var(--digi--form-file-upload--font-weight);
          font-size: var(--digi--typography--body--font-size--desktop);
          white-space: nowrap;
          height: max-content;
          overflow: hidden;
          white-space: nowrap;
          text-overflow: ellipsis;
        }

        .digi-form-file-upload__button-abort {
          margin: 0;
        }
      }

      &-text-and-thumbnail-container {
        display: flex;
        align-items: center;
        justify-content: flex-start;
        width: 100%;
        min-width: 20%;
      }

      &-green-check {
        display: flex;
        align-self: baseline;
        position: relative;
        content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' %3E%3Cg fill='none' fill-rule='evenodd'%3E%3Ccircle fill='%23FFF' cx='8' cy='8' r='6'/%3E%3Cpath d='M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0Zm-8.925 4.236L13.01 6.3a.516.516 0 0 0 0-.73l-.73-.73a.516.516 0 0 0-.73 0L6.71 9.682l-2.26-2.26a.516.516 0 0 0-.73 0l-.73.73a.516.516 0 0 0 0 .73l3.355 3.355a.516.516 0 0 0 .73 0Z' fill='%23009322'/%3E%3C/g%3E%3C/svg%3E");
        top: 4px;
        left: 0px;
        width: rem(22);
        height: rem(22);
      }

      &-name {
        width: 100%;
        margin: auto 0;
        font-weight: var(--digi--typography--button--font-weight--desktop);
        font-size: var(--digi--typography--body--font-size--desktop);
        height: max-content;

        &--thumbnail {
          font-weight: var(--digi--typography--button--font-weight--desktop);
          font-size: var(--digi--typography--body--font-size--desktop);
          margin: auto 0 auto var(--digi--margin--small);
          color: var(--digi--form-file-upload--button-text--color--default);
        }

        @media (max-width: 500px) {
          max-width: 17.5rem;
        }
        
        &:focus-visible{
          @include digi--focus();
        }
      }

      .digi-form-file-upload__item-name {
        @container (max-width: 500px) {
          max-width: 17.5rem;
        }
      }

      &-text-container {
        position: relative;
        display: flex;
        padding: 0;
        margin: 0;
        justify-content: space-between;
        align-items: center;

        &-inner {
          display: flex;
          width: 100%;
        }

        &-figure {
          margin: 0;
          align-self: flex-start;

          &::after {
            position: absolute;
            content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' %3E%3Cg fill='none' fill-rule='evenodd'%3E%3Ccircle fill='%23FFF' cx='8' cy='8' r='6'/%3E%3Cpath d='M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0Zm-8.925 4.236L13.01 6.3a.516.516 0 0 0 0-.73l-.73-.73a.516.516 0 0 0-.73 0L6.71 9.682l-2.26-2.26a.516.516 0 0 0-.73 0l-.73.73a.516.516 0 0 0 0 .73l3.355 3.355a.516.516 0 0 0 .73 0Z' fill='%23009322'/%3E%3C/g%3E%3C/svg%3E");
            top: -6px;
            left: 24px;
            width: 18px;
            height: 18px;
            overflow: hidden;
          }
        }

        .thumbnail {
          width: rem(32);
          height: rem(32);
          object-fit: cover;
          flex-grow: 0;
          margin-right: rem(12);
        }

        .hidden {
          margin-left: var(--digi--margin--larger);
        }
      }

      &-pdf-preview-bis {
        position: relative;
        top: 6px;
        left: 5px;
        margin-right: rem(12);

        &::after {
          position: absolute;
          content: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' %3E%3Cg fill='none' fill-rule='evenodd'%3E%3Ccircle fill='%23FFF' cx='8' cy='8' r='6'/%3E%3Cpath d='M16 8A8 8 0 1 1 0 8a8 8 0 0 1 16 0Zm-8.925 4.236L13.01 6.3a.516.516 0 0 0 0-.73l-.73-.73a.516.516 0 0 0-.73 0L6.71 9.682l-2.26-2.26a.516.516 0 0 0-.73 0l-.73.73a.516.516 0 0 0 0 .73l3.355 3.355a.516.516 0 0 0 .73 0Z' fill='%23009322'/%3E%3C/g%3E%3C/svg%3E");
          top: -7px;
          left: 15px;
          width: 18px;
          height: 18px;
          overflow: hidden;
        }
      }

      &-info {
        width: 100%;
      }

      .digi-form-file-upload__item {
        span {
          @container (max-width: 500px) {
            margin-left: 0;
            margin-right: auto;
          }
        }
      }
    }

    &__error {
      color: var(--digi--color--icons--danger);
    }
  }

  .visually-hidden {
    @include digi--a11y--sr-only;
  }

  .hidden-desktop {
    @container (min-width: 500px) {
      display: none !important;
    }
  }

  .hidden-mobile {
    @container (max-width: 499px) {
      display: none !important;
    }
  }
}
